Package org.apache.sysds.runtime.meta

## Class MatrixCharacteristics

- java.lang.Object
- - org.apache.sysds.runtime.meta.DataCharacteristics
  - - org.apache.sysds.runtime.meta.MatrixCharacteristics

All Implemented Interfaces:
  `Serializable`

    public class MatrixCharacteristics
    extends DataCharacteristics

See Also:
  Serialized Form

### Constructor Summary

Constructors
`MatrixCharacteristics()`
`MatrixCharacteristics​(long nr, long nc)`
`MatrixCharacteristics​(long nr, long nc, int blen)`
`MatrixCharacteristics​(long nr, long nc, int blen, long nnz)`
`MatrixCharacteristics​(long nr, long nc, long nnz)`
`MatrixCharacteristics​(DataCharacteristics that)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `colsKnown()`
`boolean` `dimsKnown()`
`boolean` `dimsKnown​(boolean includeNnz)`
`boolean` `equalDims​(Object anObject)`
`boolean` `equals​(Object anObject)`
`long` `getCols()`
`long` `getDim​(int i)`
`int[]` `getIntDims()`
`long` `getLength()`
`long[]` `getLongDims()`
`long` `getNonZeros()`
`long` `getNonZerosBound()`
`long` `getNumBlocks​(int i)`
`long` `getNumColBlocks()`
`int` `getNumDims()`
`long` `getNumRowBlocks()`
`long` `getRows()`
`double` `getSparsity()`
`int` `hashCode()`
`boolean` `isUltraSparse()`
`boolean` `mightHaveEmptyBlocks()`
`boolean` `nnzKnown()`
`boolean` `rowsKnown()`
`DataCharacteristics` `set​(long[] dims, int blocksize)`
`DataCharacteristics` `set​(long[] dims, int blocksize, long nnz)`
`DataCharacteristics` `set​(long nr, long nc, int blen)`
`DataCharacteristics` `set​(long nr, long nc, int blen, long nnz)`
`DataCharacteristics` `set​(DataCharacteristics that)`
`DataCharacteristics` `setCols​(long clen)`
`DataCharacteristics` `setDim​(int i, long dim)`
`DataCharacteristics` `setDimension​(long nr, long nc)`
`DataCharacteristics` `setDims​(long[] dims)`
`DataCharacteristics` `setNonZeros​(long nnz)`
`DataCharacteristics` `setNonZerosBound​(long nnz)`
`DataCharacteristics` `setRows​(long rlen)`
`String` `toString()`

### Methods inherited from class org.apache.sysds.runtime.meta.DataCharacteristics

`getBlocksize, getDims, getNumBlocks, isNoEmptyBlocks, setBlocksize, setNoEmptyBlocks`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### MatrixCharacteristics

    public MatrixCharacteristics()

#### MatrixCharacteristics

    public MatrixCharacteristics​(long nr,
                                 long nc)

#### MatrixCharacteristics

    public MatrixCharacteristics​(long nr,
                                 long nc,
                                 long nnz)

#### MatrixCharacteristics

    public MatrixCharacteristics​(long nr,
                                 long nc,
                                 int blen)

#### MatrixCharacteristics

    public MatrixCharacteristics​(long nr,
                                 long nc,
                                 int blen,
                                 long nnz)

#### MatrixCharacteristics

    public MatrixCharacteristics​(DataCharacteristics that)

### Method Detail

#### set

    public DataCharacteristics set​(long nr,
                                   long nc,
                                   int blen)

Specified by:
  `set` in class `DataCharacteristics`

#### set

    public DataCharacteristics set​(long nr,
                                   long nc,
                                   int blen,
                                   long nnz)

Specified by:
  `set` in class `DataCharacteristics`

#### set

    public DataCharacteristics set​(DataCharacteristics that)

Specified by:
  `set` in class `DataCharacteristics`

#### getRows

    public long getRows()

Specified by:
  `getRows` in class `DataCharacteristics`

#### setRows

    public DataCharacteristics setRows​(long rlen)

Specified by:
  `setRows` in class `DataCharacteristics`

#### getCols

    public long getCols()

Specified by:
  `getCols` in class `DataCharacteristics`

#### setCols

    public DataCharacteristics setCols​(long clen)

Specified by:
  `setCols` in class `DataCharacteristics`

#### getLength

    public long getLength()

Specified by:
  `getLength` in class `DataCharacteristics`

#### getNumRowBlocks

    public long getNumRowBlocks()

Specified by:
  `getNumRowBlocks` in class `DataCharacteristics`

#### getNumColBlocks

    public long getNumColBlocks()

Specified by:
  `getNumColBlocks` in class `DataCharacteristics`

#### setDimension

    public DataCharacteristics setDimension​(long nr,
                                            long nc)

Specified by:
  `setDimension` in class `DataCharacteristics`

#### getDim

    public long getDim​(int i)

Specified by:
  `getDim` in class `DataCharacteristics`

#### getLongDims

    public long[] getLongDims()

Specified by:
  `getLongDims` in class `DataCharacteristics`

#### getIntDims

    public int[] getIntDims()

Specified by:
  `getIntDims` in class `DataCharacteristics`

#### getNumDims

    public int getNumDims()

Specified by:
  `getNumDims` in class `DataCharacteristics`

#### setNonZeros

    public DataCharacteristics setNonZeros​(long nnz)

Specified by:
  `setNonZeros` in class `DataCharacteristics`

#### getNonZeros

    public long getNonZeros()

Specified by:
  `getNonZeros` in class `DataCharacteristics`

#### setNonZerosBound

    public DataCharacteristics setNonZerosBound​(long nnz)

Specified by:
  `setNonZerosBound` in class `DataCharacteristics`

#### getNonZerosBound

    public long getNonZerosBound()

Specified by:
  `getNonZerosBound` in class `DataCharacteristics`

#### getSparsity

    public double getSparsity()

Specified by:
  `getSparsity` in class `DataCharacteristics`

#### dimsKnown

    public boolean dimsKnown()

Specified by:
  `dimsKnown` in class `DataCharacteristics`

#### dimsKnown

    public boolean dimsKnown​(boolean includeNnz)

Specified by:
  `dimsKnown` in class `DataCharacteristics`

#### rowsKnown

    public boolean rowsKnown()

Specified by:
  `rowsKnown` in class `DataCharacteristics`

#### colsKnown

    public boolean colsKnown()

Specified by:
  `colsKnown` in class `DataCharacteristics`

#### nnzKnown

    public boolean nnzKnown()

Specified by:
  `nnzKnown` in class `DataCharacteristics`

#### isUltraSparse

    public boolean isUltraSparse()

Specified by:
  `isUltraSparse` in class `DataCharacteristics`

#### mightHaveEmptyBlocks

    public boolean mightHaveEmptyBlocks()

Specified by:
  `mightHaveEmptyBlocks` in class `DataCharacteristics`

#### equalDims

    public boolean equalDims​(Object anObject)

Specified by:
  `equalDims` in class `DataCharacteristics`

#### equals

    public boolean equals​(Object anObject)

Specified by:
  `equals` in class `DataCharacteristics`

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `DataCharacteristics`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### set

    public DataCharacteristics set​(long[] dims,
                                   int blocksize)

Specified by:
  `set` in class `DataCharacteristics`

#### set

    public DataCharacteristics set​(long[] dims,
                                   int blocksize,
                                   long nnz)

Specified by:
  `set` in class `DataCharacteristics`

#### setDim

    public DataCharacteristics setDim​(int i,
                                      long dim)

Specified by:
  `setDim` in class `DataCharacteristics`

#### setDims

    public DataCharacteristics setDims​(long[] dims)

Specified by:
  `setDims` in class `DataCharacteristics`

#### getNumBlocks

    public long getNumBlocks​(int i)

Specified by:
  `getNumBlocks` in class `DataCharacteristics`